#ifndef TRACE_H
#define TRACE_H

/* This file is autogenerated by tracetool, do not edit. */

#include "qemu-common.h"
#include "trace-dtrace.h"

static inline void trace_qemu_malloc(size_t size, void *ptr) {
    if (QEMU_QEMU_MALLOC_ENABLED()) {
        QEMU_QEMU_MALLOC(size, ptr);
    }
}

static inline void trace_qemu_realloc(void *ptr, size_t size, void *newptr) {
    if (QEMU_QEMU_REALLOC_ENABLED()) {
        QEMU_QEMU_REALLOC(ptr, size, newptr);
    }
}

static inline void trace_qemu_free(void *ptr) {
    if (QEMU_QEMU_FREE_ENABLED()) {
        QEMU_QEMU_FREE(ptr);
    }
}

static inline void trace_qemu_memalign(size_t alignment, size_t size, void *ptr) {
    if (QEMU_QEMU_MEMALIGN_ENABLED()) {
        QEMU_QEMU_MEMALIGN(alignment, size, ptr);
    }
}

static inline void trace_qemu_vmalloc(size_t size, void *ptr) {
    if (QEMU_QEMU_VMALLOC_ENABLED()) {
        QEMU_QEMU_VMALLOC(size, ptr);
    }
}

static inline void trace_qemu_vfree(void *ptr) {
    if (QEMU_QEMU_VFREE_ENABLED()) {
        QEMU_QEMU_VFREE(ptr);
    }
}

static inline void trace_virtqueue_fill(void *vq, const void *elem, unsigned int len, unsigned int idx) {
    if (QEMU_VIRTQUEUE_FILL_ENABLED()) {
        QEMU_VIRTQUEUE_FILL(vq, elem, len, idx);
    }
}

static inline void trace_virtqueue_flush(void *vq, unsigned int count) {
    if (QEMU_VIRTQUEUE_FLUSH_ENABLED()) {
        QEMU_VIRTQUEUE_FLUSH(vq, count);
    }
}

static inline void trace_virtqueue_pop(void *vq, void *elem, unsigned int in_num, unsigned int out_num) {
    if (QEMU_VIRTQUEUE_POP_ENABLED()) {
        QEMU_VIRTQUEUE_POP(vq, elem, in_num, out_num);
    }
}

static inline void trace_virtio_queue_notify(void *vdev, int n, void *vq) {
    if (QEMU_VIRTIO_QUEUE_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_QUEUE_NOTIFY(vdev, n, vq);
    }
}

static inline void trace_virtio_irq(void *vq) {
    if (QEMU_VIRTIO_IRQ_ENABLED()) {
        QEMU_VIRTIO_IRQ(vq);
    }
}

static inline void trace_virtio_notify(void *vdev, void *vq) {
    if (QEMU_VIRTIO_NOTIFY_ENABLED()) {
        QEMU_VIRTIO_NOTIFY(vdev, vq);
    }
}

static inline void trace_virtio_serial_send_control_event(unsigned int port, uint16_t event, uint16_t value) {
    if (QEMU_VIRTIO_SERIAL_SEND_CONTROL_EVENT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_SEND_CONTROL_EVENT(port, event, value);
    }
}

static inline void trace_virtio_serial_throttle_port(unsigned int port, bool throttle) {
    if (QEMU_VIRTIO_SERIAL_THROTTLE_PORT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_THROTTLE_PORT(port, throttle);
    }
}

static inline void trace_virtio_serial_handle_control_message(uint16_t event, uint16_t value) {
    if (QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_ENABLED()) {
        QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE(event, value);
    }
}

static inline void trace_virtio_serial_handle_control_message_port(unsigned int port) {
    if (QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT_ENABLED()) {
        QEMU_VIRTIO_SERIAL_HANDLE_CONTROL_MESSAGE_PORT(port);
    }
}

static inline void trace_virtio_console_flush_buf(unsigned int port, size_t len, ssize_t ret) {
    if (QEMU_VIRTIO_CONSOLE_FLUSH_BUF_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_FLUSH_BUF(port, len, ret);
    }
}

static inline void trace_virtio_console_chr_read(unsigned int port, int size) {
    if (QEMU_VIRTIO_CONSOLE_CHR_READ_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_READ(port, size);
    }
}

static inline void trace_virtio_console_chr_event(unsigned int port, int event) {
    if (QEMU_VIRTIO_CONSOLE_CHR_EVENT_ENABLED()) {
        QEMU_VIRTIO_CONSOLE_CHR_EVENT(port, event);
    }
}

static inline void trace_multiwrite_cb(void *mcb, int ret) {
    if (QEMU_MULTIWRITE_CB_ENABLED()) {
        QEMU_MULTIWRITE_CB(mcb, ret);
    }
}

static inline void trace_bdrv_aio_multiwrite(void *mcb, int num_callbacks, int num_reqs) {
    if (QEMU_BDRV_AIO_MULTIWRITE_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE(mcb, num_callbacks, num_reqs);
    }
}

static inline void trace_bdrv_aio_multiwrite_earlyfail(void *mcb) {
    if (QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_EARLYFAIL(mcb);
    }
}

static inline void trace_bdrv_aio_multiwrite_latefail(void *mcb, int i) {
    if (QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL_ENABLED()) {
        QEMU_BDRV_AIO_MULTIWRITE_LATEFAIL(mcb, i);
    }
}

static inline void trace_bdrv_aio_flush(void *bs, void *opaque) {
    if (QEMU_BDRV_AIO_FLUSH_ENABLED()) {
        QEMU_BDRV_AIO_FLUSH(bs, opaque);
    }
}

static inline void trace_bdrv_aio_readv(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_READV_ENABLED()) {
        QEMU_BDRV_AIO_READV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_aio_writev(void *bs, int64_t sector_num, int nb_sectors, void *opaque) {
    if (QEMU_BDRV_AIO_WRITEV_ENABLED()) {
        QEMU_BDRV_AIO_WRITEV(bs, sector_num, nb_sectors, opaque);
    }
}

static inline void trace_bdrv_set_locked(void *bs, int locked) {
    if (QEMU_BDRV_SET_LOCKED_ENABLED()) {
        QEMU_BDRV_SET_LOCKED(bs, locked);
    }
}

static inline void trace_virtio_blk_req_complete(void *req, int status) {
    if (QEMU_VIRTIO_BLK_REQ_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_REQ_COMPLETE(req, status);
    }
}

static inline void trace_virtio_blk_rw_complete(void *req, int ret) {
    if (QEMU_VIRTIO_BLK_RW_COMPLETE_ENABLED()) {
        QEMU_VIRTIO_BLK_RW_COMPLETE(req, ret);
    }
}

static inline void trace_virtio_blk_handle_write(void *req, uint64_t sector, size_t nsectors) {
    if (QEMU_VIRTIO_BLK_HANDLE_WRITE_ENABLED()) {
        QEMU_VIRTIO_BLK_HANDLE_WRITE(req, sector, nsectors);
    }
}

static inline void trace_paio_submit(void *acb, void *opaque, int64_t sector_num, int nb_sectors, int type) {
    if (QEMU_PAIO_SUBMIT_ENABLED()) {
        QEMU_PAIO_SUBMIT(acb, opaque, sector_num, nb_sectors, type);
    }
}

static inline void trace_paio_complete(void *acb, void *opaque, int ret) {
    if (QEMU_PAIO_COMPLETE_ENABLED()) {
        QEMU_PAIO_COMPLETE(acb, opaque, ret);
    }
}

static inline void trace_paio_cancel(void *acb, void *opaque) {
    if (QEMU_PAIO_CANCEL_ENABLED()) {
        QEMU_PAIO_CANCEL(acb, opaque);
    }
}

static inline void trace_cpu_in(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_IN_ENABLED()) {
        QEMU_CPU_IN(addr, val);
    }
}

static inline void trace_cpu_out(unsigned int addr, unsigned int val) {
    if (QEMU_CPU_OUT_ENABLED()) {
        QEMU_CPU_OUT(addr, val);
    }
}

static inline void trace_balloon_event(void *opaque, unsigned long addr) {
    if (QEMU_BALLOON_EVENT_ENABLED()) {
        QEMU_BALLOON_EVENT(opaque, addr);
    }
}

static inline void trace_apic_local_deliver(int vector, uint32_t lvt) {
    if (QEMU_APIC_LOCAL_DELIVER_ENABLED()) {
        QEMU_APIC_LOCAL_DELIVER(vector, lvt);
    }
}

static inline void trace_apic_deliver_irq(uint8_t dest, uint8_t dest_mode, uint8_t delivery_mode, uint8_t vector_num, uint8_t polarity, uint8_t trigger_mode) {
    if (QEMU_APIC_DELIVER_IRQ_ENABLED()) {
        QEMU_APIC_DELIVER_IRQ(dest, dest_mode, delivery_mode, vector_num, polarity, trigger_mode);
    }
}

static inline void trace_cpu_set_apic_base(uint64_t val) {
    if (QEMU_CPU_SET_APIC_BASE_ENABLED()) {
        QEMU_CPU_SET_APIC_BASE(val);
    }
}

static inline void trace_cpu_get_apic_base(uint64_t val) {
    if (QEMU_CPU_GET_APIC_BASE_ENABLED()) {
        QEMU_CPU_GET_APIC_BASE(val);
    }
}

static inline void trace_apic_mem_readl(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_READL_ENABLED()) {
        QEMU_APIC_MEM_READL(addr, val);
    }
}

static inline void trace_apic_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_APIC_MEM_WRITEL_ENABLED()) {
        QEMU_APIC_MEM_WRITEL(addr, val);
    }
}

static inline void trace_apic_reset_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_RESET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_RESET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_get_irq_delivered(int apic_irq_delivered) {
    if (QEMU_APIC_GET_IRQ_DELIVERED_ENABLED()) {
        QEMU_APIC_GET_IRQ_DELIVERED(apic_irq_delivered);
    }
}

static inline void trace_apic_set_irq(int apic_irq_delivered) {
    if (QEMU_APIC_SET_IRQ_ENABLED()) {
        QEMU_APIC_SET_IRQ(apic_irq_delivered);
    }
}

static inline void trace_cs4231_mem_readl_dreg(uint32_t reg, uint32_t ret) {
    if (QEMU_CS4231_MEM_READL_DREG_ENABLED()) {
        QEMU_CS4231_MEM_READL_DREG(reg, ret);
    }
}

static inline void trace_cs4231_mem_readl_reg(uint32_t reg, uint32_t ret) {
    if (QEMU_CS4231_MEM_READL_REG_ENABLED()) {
        QEMU_CS4231_MEM_READL_REG(reg, ret);
    }
}

static inline void trace_cs4231_mem_writel_reg(uint32_t reg, uint32_t old, uint32_t val) {
    if (QEMU_CS4231_MEM_WRITEL_REG_ENABLED()) {
        QEMU_CS4231_MEM_WRITEL_REG(reg, old, val);
    }
}

static inline void trace_cs4231_mem_writel_dreg(uint32_t reg, uint32_t old, uint32_t val) {
    if (QEMU_CS4231_MEM_WRITEL_DREG_ENABLED()) {
        QEMU_CS4231_MEM_WRITEL_DREG(reg, old, val);
    }
}

static inline void trace_nvram_read(uint32_t addr, uint32_t ret) {
    if (QEMU_NVRAM_READ_ENABLED()) {
        QEMU_NVRAM_READ(addr, ret);
    }
}

static inline void trace_nvram_write(uint32_t addr, uint32_t old, uint32_t val) {
    if (QEMU_NVRAM_WRITE_ENABLED()) {
        QEMU_NVRAM_WRITE(addr, old, val);
    }
}

static inline void trace_ecc_mem_writel_mer(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MER_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MER(val);
    }
}

static inline void trace_ecc_mem_writel_mdr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MDR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MDR(val);
    }
}

static inline void trace_ecc_mem_writel_mfsr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_MFSR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_MFSR(val);
    }
}

static inline void trace_ecc_mem_writel_vcr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_VCR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_VCR(val);
    }
}

static inline void trace_ecc_mem_writel_dr(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_DR_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_DR(val);
    }
}

static inline void trace_ecc_mem_writel_ecr0(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_ECR0_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_ECR0(val);
    }
}

static inline void trace_ecc_mem_writel_ecr1(uint32_t val) {
    if (QEMU_ECC_MEM_WRITEL_ECR1_ENABLED()) {
        QEMU_ECC_MEM_WRITEL_ECR1(val);
    }
}

static inline void trace_ecc_mem_readl_mer(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MER_ENABLED()) {
        QEMU_ECC_MEM_READL_MER(ret);
    }
}

static inline void trace_ecc_mem_readl_mdr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MDR_ENABLED()) {
        QEMU_ECC_MEM_READL_MDR(ret);
    }
}

static inline void trace_ecc_mem_readl_mfsr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFSR_ENABLED()) {
        QEMU_ECC_MEM_READL_MFSR(ret);
    }
}

static inline void trace_ecc_mem_readl_vcr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_VCR_ENABLED()) {
        QEMU_ECC_MEM_READL_VCR(ret);
    }
}

static inline void trace_ecc_mem_readl_mfar0(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFAR0_ENABLED()) {
        QEMU_ECC_MEM_READL_MFAR0(ret);
    }
}

static inline void trace_ecc_mem_readl_mfar1(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_MFAR1_ENABLED()) {
        QEMU_ECC_MEM_READL_MFAR1(ret);
    }
}

static inline void trace_ecc_mem_readl_dr(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_DR_ENABLED()) {
        QEMU_ECC_MEM_READL_DR(ret);
    }
}

static inline void trace_ecc_mem_readl_ecr0(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_ECR0_ENABLED()) {
        QEMU_ECC_MEM_READL_ECR0(ret);
    }
}

static inline void trace_ecc_mem_readl_ecr1(uint32_t ret) {
    if (QEMU_ECC_MEM_READL_ECR1_ENABLED()) {
        QEMU_ECC_MEM_READL_ECR1(ret);
    }
}

static inline void trace_ecc_diag_mem_writeb(uint64_t addr, uint32_t val) {
    if (QEMU_ECC_DIAG_MEM_WRITEB_ENABLED()) {
        QEMU_ECC_DIAG_MEM_WRITEB(addr, val);
    }
}

static inline void trace_ecc_diag_mem_readb(uint64_t addr, uint32_t ret) {
    if (QEMU_ECC_DIAG_MEM_READB_ENABLED()) {
        QEMU_ECC_DIAG_MEM_READB(addr, ret);
    }
}

static inline void trace_lance_mem_readw(uint64_t addr, uint32_t ret) {
    if (QEMU_LANCE_MEM_READW_ENABLED()) {
        QEMU_LANCE_MEM_READW(addr, ret);
    }
}

static inline void trace_lance_mem_writew(uint64_t addr, uint32_t val) {
    if (QEMU_LANCE_MEM_WRITEW_ENABLED()) {
        QEMU_LANCE_MEM_WRITEW(addr, val);
    }
}

static inline void trace_slavio_intctl_mem_readl(uint32_t cpu, uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_INTCTL_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_READL(cpu, addr, ret);
    }
}

static inline void trace_slavio_intctl_mem_writel(uint32_t cpu, uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL(cpu, addr, val);
    }
}

static inline void trace_slavio_intctl_mem_writel_clear(uint32_t cpu, uint32_t val, uint32_t intreg_pending) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_CLEAR_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL_CLEAR(cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctl_mem_writel_set(uint32_t cpu, uint32_t val, uint32_t intreg_pending) {
    if (QEMU_SLAVIO_INTCTL_MEM_WRITEL_SET_ENABLED()) {
        QEMU_SLAVIO_INTCTL_MEM_WRITEL_SET(cpu, val, intreg_pending);
    }
}

static inline void trace_slavio_intctlm_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_INTCTLM_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_READL(addr, ret);
    }
}

static inline void trace_slavio_intctlm_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL(addr, val);
    }
}

static inline void trace_slavio_intctlm_mem_writel_enable(uint32_t val, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_ENABLE(val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_disable(uint32_t val, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_DISABLE(val, intregm_disabled);
    }
}

static inline void trace_slavio_intctlm_mem_writel_target(uint32_t cpu) {
    if (QEMU_SLAVIO_INTCTLM_MEM_WRITEL_TARGET_ENABLED()) {
        QEMU_SLAVIO_INTCTLM_MEM_WRITEL_TARGET(cpu);
    }
}

static inline void trace_slavio_check_interrupts(uint32_t pending, uint32_t intregm_disabled) {
    if (QEMU_SLAVIO_CHECK_INTERRUPTS_ENABLED()) {
        QEMU_SLAVIO_CHECK_INTERRUPTS(pending, intregm_disabled);
    }
}

static inline void trace_slavio_set_irq(uint32_t target_cpu, int irq, uint32_t pil, int level) {
    if (QEMU_SLAVIO_SET_IRQ_ENABLED()) {
        QEMU_SLAVIO_SET_IRQ(target_cpu, irq, pil, level);
    }
}

static inline void trace_slavio_set_timer_irq_cpu(int cpu, int level) {
    if (QEMU_SLAVIO_SET_TIMER_IRQ_CPU_ENABLED()) {
        QEMU_SLAVIO_SET_TIMER_IRQ_CPU(cpu, level);
    }
}

static inline void trace_slavio_misc_update_irq_raise(void) {
    if (QEMU_SLAVIO_MISC_UPDATE_IRQ_RAISE_ENABLED()) {
        QEMU_SLAVIO_MISC_UPDATE_IRQ_RAISE();
    }
}

static inline void trace_slavio_misc_update_irq_lower(void) {
    if (QEMU_SLAVIO_MISC_UPDATE_IRQ_LOWER_ENABLED()) {
        QEMU_SLAVIO_MISC_UPDATE_IRQ_LOWER();
    }
}

static inline void trace_slavio_set_power_fail(int power_failing, uint8_t config) {
    if (QEMU_SLAVIO_SET_POWER_FAIL_ENABLED()) {
        QEMU_SLAVIO_SET_POWER_FAIL(power_failing, config);
    }
}

static inline void trace_slavio_cfg_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_CFG_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_CFG_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_cfg_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_CFG_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_CFG_MEM_READB(ret);
    }
}

static inline void trace_slavio_diag_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_DIAG_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_DIAG_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_diag_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_DIAG_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_DIAG_MEM_READB(ret);
    }
}

static inline void trace_slavio_mdm_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_MDM_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_MDM_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_mdm_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_MDM_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_MDM_MEM_READB(ret);
    }
}

static inline void trace_slavio_aux1_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_AUX1_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_AUX1_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_aux1_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_AUX1_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_AUX1_MEM_READB(ret);
    }
}

static inline void trace_slavio_aux2_mem_writeb(uint32_t val) {
    if (QEMU_SLAVIO_AUX2_MEM_WRITEB_ENABLED()) {
        QEMU_SLAVIO_AUX2_MEM_WRITEB(val);
    }
}

static inline void trace_slavio_aux2_mem_readb(uint32_t ret) {
    if (QEMU_SLAVIO_AUX2_MEM_READB_ENABLED()) {
        QEMU_SLAVIO_AUX2_MEM_READB(ret);
    }
}

static inline void trace_apc_mem_writeb(uint32_t val) {
    if (QEMU_APC_MEM_WRITEB_ENABLED()) {
        QEMU_APC_MEM_WRITEB(val);
    }
}

static inline void trace_apc_mem_readb(uint32_t ret) {
    if (QEMU_APC_MEM_READB_ENABLED()) {
        QEMU_APC_MEM_READB(ret);
    }
}

static inline void trace_slavio_sysctrl_mem_writel(uint32_t val) {
    if (QEMU_SLAVIO_SYSCTRL_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_SYSCTRL_MEM_WRITEL(val);
    }
}

static inline void trace_slavio_sysctrl_mem_readl(uint32_t ret) {
    if (QEMU_SLAVIO_SYSCTRL_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_SYSCTRL_MEM_READL(ret);
    }
}

static inline void trace_slavio_led_mem_writew(uint32_t val) {
    if (QEMU_SLAVIO_LED_MEM_WRITEW_ENABLED()) {
        QEMU_SLAVIO_LED_MEM_WRITEW(val);
    }
}

static inline void trace_slavio_led_mem_readw(uint32_t ret) {
    if (QEMU_SLAVIO_LED_MEM_READW_ENABLED()) {
        QEMU_SLAVIO_LED_MEM_READW(ret);
    }
}

static inline void trace_slavio_timer_get_out(uint64_t limit, uint32_t counthigh, uint32_t count) {
    if (QEMU_SLAVIO_TIMER_GET_OUT_ENABLED()) {
        QEMU_SLAVIO_TIMER_GET_OUT(limit, counthigh, count);
    }
}

static inline void trace_slavio_timer_irq(uint32_t counthigh, uint32_t count) {
    if (QEMU_SLAVIO_TIMER_IRQ_ENABLED()) {
        QEMU_SLAVIO_TIMER_IRQ(counthigh, count);
    }
}

static inline void trace_slavio_timer_mem_readl_invalid(uint64_t addr) {
    if (QEMU_SLAVIO_TIMER_MEM_READL_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_READL_INVALID(addr);
    }
}

static inline void trace_slavio_timer_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SLAVIO_TIMER_MEM_READL_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_READL(addr, ret);
    }
}

static inline void trace_slavio_timer_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL(addr, val);
    }
}

static inline void trace_slavio_timer_mem_writel_limit(unsigned int timer_index, uint64_t count) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_LIMIT_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_LIMIT(timer_index, count);
    }
}

static inline void trace_slavio_timer_mem_writel_counter_invalid(void) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_COUNTER_INVALID();
    }
}

static inline void trace_slavio_timer_mem_writel_status_start(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_START_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_START(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_status_stop(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_STATUS_STOP(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_user(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_USER_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_USER(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_counter(unsigned int timer_index) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_COUNTER(timer_index);
    }
}

static inline void trace_slavio_timer_mem_writel_mode_invalid(void) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_MODE_INVALID();
    }
}

static inline void trace_slavio_timer_mem_writel_invalid(uint64_t addr) {
    if (QEMU_SLAVIO_TIMER_MEM_WRITEL_INVALID_ENABLED()) {
        QEMU_SLAVIO_TIMER_MEM_WRITEL_INVALID(addr);
    }
}

static inline void trace_ledma_memory_read(uint64_t addr) {
    if (QEMU_LEDMA_MEMORY_READ_ENABLED()) {
        QEMU_LEDMA_MEMORY_READ(addr);
    }
}

static inline void trace_ledma_memory_write(uint64_t addr) {
    if (QEMU_LEDMA_MEMORY_WRITE_ENABLED()) {
        QEMU_LEDMA_MEMORY_WRITE(addr);
    }
}

static inline void trace_sparc32_dma_set_irq_raise(void) {
    if (QEMU_SPARC32_DMA_SET_IRQ_RAISE_ENABLED()) {
        QEMU_SPARC32_DMA_SET_IRQ_RAISE();
    }
}

static inline void trace_sparc32_dma_set_irq_lower(void) {
    if (QEMU_SPARC32_DMA_SET_IRQ_LOWER_ENABLED()) {
        QEMU_SPARC32_DMA_SET_IRQ_LOWER();
    }
}

static inline void trace_espdma_memory_read(uint32_t addr) {
    if (QEMU_ESPDMA_MEMORY_READ_ENABLED()) {
        QEMU_ESPDMA_MEMORY_READ(addr);
    }
}

static inline void trace_espdma_memory_write(uint32_t addr) {
    if (QEMU_ESPDMA_MEMORY_WRITE_ENABLED()) {
        QEMU_ESPDMA_MEMORY_WRITE(addr);
    }
}

static inline void trace_sparc32_dma_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SPARC32_DMA_MEM_READL_ENABLED()) {
        QEMU_SPARC32_DMA_MEM_READL(addr, ret);
    }
}

static inline void trace_sparc32_dma_mem_writel(uint64_t addr, uint32_t old, uint32_t val) {
    if (QEMU_SPARC32_DMA_MEM_WRITEL_ENABLED()) {
        QEMU_SPARC32_DMA_MEM_WRITEL(addr, old, val);
    }
}

static inline void trace_sparc32_dma_enable_raise(void) {
    if (QEMU_SPARC32_DMA_ENABLE_RAISE_ENABLED()) {
        QEMU_SPARC32_DMA_ENABLE_RAISE();
    }
}

static inline void trace_sparc32_dma_enable_lower(void) {
    if (QEMU_SPARC32_DMA_ENABLE_LOWER_ENABLED()) {
        QEMU_SPARC32_DMA_ENABLE_LOWER();
    }
}

static inline void trace_sun4m_cpu_interrupt(unsigned int level) {
    if (QEMU_SUN4M_CPU_INTERRUPT_ENABLED()) {
        QEMU_SUN4M_CPU_INTERRUPT(level);
    }
}

static inline void trace_sun4m_cpu_reset_interrupt(unsigned int level) {
    if (QEMU_SUN4M_CPU_RESET_INTERRUPT_ENABLED()) {
        QEMU_SUN4M_CPU_RESET_INTERRUPT(level);
    }
}

static inline void trace_sun4m_cpu_set_irq_raise(int level) {
    if (QEMU_SUN4M_CPU_SET_IRQ_RAISE_ENABLED()) {
        QEMU_SUN4M_CPU_SET_IRQ_RAISE(level);
    }
}

static inline void trace_sun4m_cpu_set_irq_lower(int level) {
    if (QEMU_SUN4M_CPU_SET_IRQ_LOWER_ENABLED()) {
        QEMU_SUN4M_CPU_SET_IRQ_LOWER(level);
    }
}

static inline void trace_sun4m_iommu_mem_readl(uint64_t addr, uint32_t ret) {
    if (QEMU_SUN4M_IOMMU_MEM_READL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_READL(addr, ret);
    }
}

static inline void trace_sun4m_iommu_mem_writel(uint64_t addr, uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL(addr, val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_ctrl(uint64_t iostart) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_CTRL_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_CTRL(iostart);
    }
}

static inline void trace_sun4m_iommu_mem_writel_tlbflush(uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_TLBFLUSH(val);
    }
}

static inline void trace_sun4m_iommu_mem_writel_pgflush(uint32_t val) {
    if (QEMU_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH_ENABLED()) {
        QEMU_SUN4M_IOMMU_MEM_WRITEL_PGFLUSH(val);
    }
}

static inline void trace_sun4m_iommu_page_get_flags(uint64_t pa, uint64_t iopte, uint32_t ret) {
    if (QEMU_SUN4M_IOMMU_PAGE_GET_FLAGS_ENABLED()) {
        QEMU_SUN4M_IOMMU_PAGE_GET_FLAGS(pa, iopte, ret);
    }
}

static inline void trace_sun4m_iommu_translate_pa(uint64_t addr, uint64_t pa, uint32_t iopte) {
    if (QEMU_SUN4M_IOMMU_TRANSLATE_PA_ENABLED()) {
        QEMU_SUN4M_IOMMU_TRANSLATE_PA(addr, pa, iopte);
    }
}

static inline void trace_sun4m_iommu_bad_addr(uint64_t addr) {
    if (QEMU_SUN4M_IOMMU_BAD_ADDR_ENABLED()) {
        QEMU_SUN4M_IOMMU_BAD_ADDR(addr);
    }
}

static inline void trace_usb_ehci_reset(void) {
    if (QEMU_USB_EHCI_RESET_ENABLED()) {
        QEMU_USB_EHCI_RESET();
    }
}

static inline void trace_usb_ehci_mmio_readl(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_READL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_READL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_writel(uint32_t addr, const char *str, uint32_t val) {
    if (QEMU_USB_EHCI_MMIO_WRITEL_ENABLED()) {
        QEMU_USB_EHCI_MMIO_WRITEL(addr, str, val);
    }
}

static inline void trace_usb_ehci_mmio_change(uint32_t addr, const char *str, uint32_t new, uint32_t old) {
    if (QEMU_USB_EHCI_MMIO_CHANGE_ENABLED()) {
        QEMU_USB_EHCI_MMIO_CHANGE(addr, str, new, old);
    }
}

static inline void trace_usb_ehci_usbsts(const char *sts, int state) {
    if (QEMU_USB_EHCI_USBSTS_ENABLED()) {
        QEMU_USB_EHCI_USBSTS(sts, state);
    }
}

static inline void trace_usb_ehci_state(const char *schedule, const char *state) {
    if (QEMU_USB_EHCI_STATE_ENABLED()) {
        QEMU_USB_EHCI_STATE(schedule, state);
    }
}

static inline void trace_usb_ehci_qh_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t c_qtd, uint32_t n_qtd, uint32_t a_qtd) {
    if (QEMU_USB_EHCI_QH_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QH_PTRS(q, addr, nxt, c_qtd, n_qtd, a_qtd);
    }
}

static inline void trace_usb_ehci_qh_fields(uint32_t addr, int rl, int mplen, int eps, int ep, int devaddr) {
    if (QEMU_USB_EHCI_QH_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QH_FIELDS(addr, rl, mplen, eps, ep, devaddr);
    }
}

static inline void trace_usb_ehci_qh_bits(uint32_t addr, int c, int h, int dtc, int i) {
    if (QEMU_USB_EHCI_QH_BITS_ENABLED()) {
        QEMU_USB_EHCI_QH_BITS(addr, c, h, dtc, i);
    }
}

static inline void trace_usb_ehci_qtd_ptrs(void *q, uint32_t addr, uint32_t nxt, uint32_t altnext) {
    if (QEMU_USB_EHCI_QTD_PTRS_ENABLED()) {
        QEMU_USB_EHCI_QTD_PTRS(q, addr, nxt, altnext);
    }
}

static inline void trace_usb_ehci_qtd_fields(uint32_t addr, int tbytes, int cpage, int cerr, int pid) {
    if (QEMU_USB_EHCI_QTD_FIELDS_ENABLED()) {
        QEMU_USB_EHCI_QTD_FIELDS(addr, tbytes, cpage, cerr, pid);
    }
}

static inline void trace_usb_ehci_qtd_bits(uint32_t addr, int ioc, int active, int halt, int babble, int xacterr) {
    if (QEMU_USB_EHCI_QTD_BITS_ENABLED()) {
        QEMU_USB_EHCI_QTD_BITS(addr, ioc, active, halt, babble, xacterr);
    }
}

static inline void trace_usb_ehci_itd(uint32_t addr, uint32_t nxt, uint32_t mplen, uint32_t mult, uint32_t ep, uint32_t devaddr) {
    if (QEMU_USB_EHCI_ITD_ENABLED()) {
        QEMU_USB_EHCI_ITD(addr, nxt, mplen, mult, ep, devaddr);
    }
}

static inline void trace_usb_ehci_port_attach(uint32_t port, const char *device) {
    if (QEMU_USB_EHCI_PORT_ATTACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_ATTACH(port, device);
    }
}

static inline void trace_usb_ehci_port_detach(uint32_t port) {
    if (QEMU_USB_EHCI_PORT_DETACH_ENABLED()) {
        QEMU_USB_EHCI_PORT_DETACH(port);
    }
}

static inline void trace_usb_ehci_port_reset(uint32_t port, int enable) {
    if (QEMU_USB_EHCI_PORT_RESET_ENABLED()) {
        QEMU_USB_EHCI_PORT_RESET(port, enable);
    }
}

static inline void trace_usb_ehci_data(int rw, uint32_t cpage, uint32_t offset, uint32_t addr, uint32_t len, uint32_t bufpos) {
    if (QEMU_USB_EHCI_DATA_ENABLED()) {
        QEMU_USB_EHCI_DATA(rw, cpage, offset, addr, len, bufpos);
    }
}

static inline void trace_usb_ehci_queue_action(void *q, const char *action) {
    if (QEMU_USB_EHCI_QUEUE_ACTION_ENABLED()) {
        QEMU_USB_EHCI_QUEUE_ACTION(q, action);
    }
}

static inline void trace_usb_desc_device(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_ENABLED()) {
        QEMU_USB_DESC_DEVICE(addr, len, ret);
    }
}

static inline void trace_usb_desc_device_qualifier(int addr, int len, int ret) {
    if (QEMU_USB_DESC_DEVICE_QUALIFIER_ENABLED()) {
        QEMU_USB_DESC_DEVICE_QUALIFIER(addr, len, ret);
    }
}

static inline void trace_usb_desc_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_CONFIG_ENABLED()) {
        QEMU_USB_DESC_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_other_speed_config(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_OTHER_SPEED_CONFIG_ENABLED()) {
        QEMU_USB_DESC_OTHER_SPEED_CONFIG(addr, index, len, ret);
    }
}

static inline void trace_usb_desc_string(int addr, int index, int len, int ret) {
    if (QEMU_USB_DESC_STRING_ENABLED()) {
        QEMU_USB_DESC_STRING(addr, index, len, ret);
    }
}

static inline void trace_usb_set_addr(int addr) {
    if (QEMU_USB_SET_ADDR_ENABLED()) {
        QEMU_USB_SET_ADDR(addr);
    }
}

static inline void trace_usb_set_config(int addr, int config, int ret) {
    if (QEMU_USB_SET_CONFIG_ENABLED()) {
        QEMU_USB_SET_CONFIG(addr, config, ret);
    }
}

static inline void trace_usb_clear_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_CLEAR_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_CLEAR_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_usb_set_device_feature(int addr, int feature, int ret) {
    if (QEMU_USB_SET_DEVICE_FEATURE_ENABLED()) {
        QEMU_USB_SET_DEVICE_FEATURE(addr, feature, ret);
    }
}

static inline void trace_scsi_req_alloc(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_ALLOC_ENABLED()) {
        QEMU_SCSI_REQ_ALLOC(target, lun, tag);
    }
}

static inline void trace_scsi_req_data(int target, int lun, int tag, int len) {
    if (QEMU_SCSI_REQ_DATA_ENABLED()) {
        QEMU_SCSI_REQ_DATA(target, lun, tag, len);
    }
}

static inline void trace_scsi_req_dequeue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_DEQUEUE_ENABLED()) {
        QEMU_SCSI_REQ_DEQUEUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_continue(int target, int lun, int tag) {
    if (QEMU_SCSI_REQ_CONTINUE_ENABLED()) {
        QEMU_SCSI_REQ_CONTINUE(target, lun, tag);
    }
}

static inline void trace_scsi_req_parsed(int target, int lun, int tag, int cmd, int mode, int xfer) {
    if (QEMU_SCSI_REQ_PARSED_ENABLED()) {
        QEMU_SCSI_REQ_PARSED(target, lun, tag, cmd, mode, xfer);
    }
}

static inline void trace_scsi_req_parsed_lba(int target, int lun, int tag, int cmd, uint64_t lba) {
    if (QEMU_SCSI_REQ_PARSED_LBA_ENABLED()) {
        QEMU_SCSI_REQ_PARSED_LBA(target, lun, tag, cmd, lba);
    }
}

static inline void trace_scsi_req_parse_bad(int target, int lun, int tag, int cmd) {
    if (QEMU_SCSI_REQ_PARSE_BAD_ENABLED()) {
        QEMU_SCSI_REQ_PARSE_BAD(target, lun, tag, cmd);
    }
}

static inline void trace_vm_state_notify(int running, int reason) {
    if (QEMU_VM_STATE_NOTIFY_ENABLED()) {
        QEMU_VM_STATE_NOTIFY(running, reason);
    }
}

static inline void trace_qed_alloc_l2_cache_entry(void *l2_cache, void *entry) {
    if (QEMU_QED_ALLOC_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_ALLOC_L2_CACHE_ENTRY(l2_cache, entry);
    }
}

static inline void trace_qed_unref_l2_cache_entry(void *entry, int ref) {
    if (QEMU_QED_UNREF_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_UNREF_L2_CACHE_ENTRY(entry, ref);
    }
}

static inline void trace_qed_find_l2_cache_entry(void *l2_cache, void *entry, uint64_t offset, int ref) {
    if (QEMU_QED_FIND_L2_CACHE_ENTRY_ENABLED()) {
        QEMU_QED_FIND_L2_CACHE_ENTRY(l2_cache, entry, offset, ref);
    }
}

static inline void trace_qed_read_table(void *s, uint64_t offset, void *table) {
    if (QEMU_QED_READ_TABLE_ENABLED()) {
        QEMU_QED_READ_TABLE(s, offset, table);
    }
}

static inline void trace_qed_read_table_cb(void *s, void *table, int ret) {
    if (QEMU_QED_READ_TABLE_CB_ENABLED()) {
        QEMU_QED_READ_TABLE_CB(s, table, ret);
    }
}

static inline void trace_qed_write_table(void *s, uint64_t offset, void *table, unsigned int index, unsigned int n) {
    if (QEMU_QED_WRITE_TABLE_ENABLED()) {
        QEMU_QED_WRITE_TABLE(s, offset, table, index, n);
    }
}

static inline void trace_qed_write_table_cb(void *s, void *table, int flush, int ret) {
    if (QEMU_QED_WRITE_TABLE_CB_ENABLED()) {
        QEMU_QED_WRITE_TABLE_CB(s, table, flush, ret);
    }
}

static inline void trace_qed_need_check_timer_cb(void *s) {
    if (QEMU_QED_NEED_CHECK_TIMER_CB_ENABLED()) {
        QEMU_QED_NEED_CHECK_TIMER_CB(s);
    }
}

static inline void trace_qed_start_need_check_timer(void *s) {
    if (QEMU_QED_START_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_START_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_cancel_need_check_timer(void *s) {
    if (QEMU_QED_CANCEL_NEED_CHECK_TIMER_ENABLED()) {
        QEMU_QED_CANCEL_NEED_CHECK_TIMER(s);
    }
}

static inline void trace_qed_aio_complete(void *s, void *acb, int ret) {
    if (QEMU_QED_AIO_COMPLETE_ENABLED()) {
        QEMU_QED_AIO_COMPLETE(s, acb, ret);
    }
}

static inline void trace_qed_aio_setup(void *s, void *acb, int64_t sector_num, int nb_sectors, void *opaque, int is_write) {
    if (QEMU_QED_AIO_SETUP_ENABLED()) {
        QEMU_QED_AIO_SETUP(s, acb, sector_num, nb_sectors, opaque, is_write);
    }
}

static inline void trace_qed_aio_next_io(void *s, void *acb, int ret, uint64_t cur_pos) {
    if (QEMU_QED_AIO_NEXT_IO_ENABLED()) {
        QEMU_QED_AIO_NEXT_IO(s, acb, ret, cur_pos);
    }
}

static inline void trace_qed_aio_read_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_READ_DATA_ENABLED()) {
        QEMU_QED_AIO_READ_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_data(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_DATA_ENABLED()) {
        QEMU_QED_AIO_WRITE_DATA(s, acb, ret, offset, len);
    }
}

static inline void trace_qed_aio_write_prefill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_PREFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_PREFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_postfill(void *s, void *acb, uint64_t start, size_t len, uint64_t offset) {
    if (QEMU_QED_AIO_WRITE_POSTFILL_ENABLED()) {
        QEMU_QED_AIO_WRITE_POSTFILL(s, acb, start, len, offset);
    }
}

static inline void trace_qed_aio_write_main(void *s, void *acb, int ret, uint64_t offset, size_t len) {
    if (QEMU_QED_AIO_WRITE_MAIN_ENABLED()) {
        QEMU_QED_AIO_WRITE_MAIN(s, acb, ret, offset, len);
    }
}

static inline void trace_grlib_gptimer_enable(int id, uint32_t count) {
    if (QEMU_GRLIB_GPTIMER_ENABLE_ENABLED()) {
        QEMU_GRLIB_GPTIMER_ENABLE(id, count);
    }
}

static inline void trace_grlib_gptimer_disabled(int id, uint32_t config) {
    if (QEMU_GRLIB_GPTIMER_DISABLED_ENABLED()) {
        QEMU_GRLIB_GPTIMER_DISABLED(id, config);
    }
}

static inline void trace_grlib_gptimer_restart(int id, uint32_t reload) {
    if (QEMU_GRLIB_GPTIMER_RESTART_ENABLED()) {
        QEMU_GRLIB_GPTIMER_RESTART(id, reload);
    }
}

static inline void trace_grlib_gptimer_set_scaler(uint32_t scaler, uint32_t freq) {
    if (QEMU_GRLIB_GPTIMER_SET_SCALER_ENABLED()) {
        QEMU_GRLIB_GPTIMER_SET_SCALER(scaler, freq);
    }
}

static inline void trace_grlib_gptimer_hit(int id) {
    if (QEMU_GRLIB_GPTIMER_HIT_ENABLED()) {
        QEMU_GRLIB_GPTIMER_HIT(id);
    }
}

static inline void trace_grlib_gptimer_readl(int id, uint64_t addr, uint32_t val) {
    if (QEMU_GRLIB_GPTIMER_READL_ENABLED()) {
        QEMU_GRLIB_GPTIMER_READL(id, addr, val);
    }
}

static inline void trace_grlib_gptimer_writel(int id, uint64_t addr, uint32_t val) {
    if (QEMU_GRLIB_GPTIMER_WRITEL_ENABLED()) {
        QEMU_GRLIB_GPTIMER_WRITEL(id, addr, val);
    }
}

static inline void trace_grlib_irqmp_check_irqs(uint32_t pend, uint32_t force, uint32_t mask, uint32_t lvl1, uint32_t lvl2) {
    if (QEMU_GRLIB_IRQMP_CHECK_IRQS_ENABLED()) {
        QEMU_GRLIB_IRQMP_CHECK_IRQS(pend, force, mask, lvl1, lvl2);
    }
}

static inline void trace_grlib_irqmp_ack(int intno) {
    if (QEMU_GRLIB_IRQMP_ACK_ENABLED()) {
        QEMU_GRLIB_IRQMP_ACK(intno);
    }
}

static inline void trace_grlib_irqmp_set_irq(int irq) {
    if (QEMU_GRLIB_IRQMP_SET_IRQ_ENABLED()) {
        QEMU_GRLIB_IRQMP_SET_IRQ(irq);
    }
}

static inline void trace_grlib_irqmp_readl_unknown(uint64_t addr) {
    if (QEMU_GRLIB_IRQMP_READL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_IRQMP_READL_UNKNOWN(addr);
    }
}

static inline void trace_grlib_irqmp_writel_unknown(uint64_t addr, uint32_t value) {
    if (QEMU_GRLIB_IRQMP_WRITEL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_IRQMP_WRITEL_UNKNOWN(addr, value);
    }
}

static inline void trace_grlib_apbuart_event(int event) {
    if (QEMU_GRLIB_APBUART_EVENT_ENABLED()) {
        QEMU_GRLIB_APBUART_EVENT(event);
    }
}

static inline void trace_grlib_apbuart_writel_unknown(uint64_t addr, uint32_t value) {
    if (QEMU_GRLIB_APBUART_WRITEL_UNKNOWN_ENABLED()) {
        QEMU_GRLIB_APBUART_WRITEL_UNKNOWN(addr, value);
    }
}

static inline void trace_leon3_set_irq(int intno) {
    if (QEMU_LEON3_SET_IRQ_ENABLED()) {
        QEMU_LEON3_SET_IRQ(intno);
    }
}

static inline void trace_leon3_reset_irq(int intno) {
    if (QEMU_LEON3_RESET_IRQ_ENABLED()) {
        QEMU_LEON3_RESET_IRQ(intno);
    }
}

static inline void trace_spice_vmc_write(ssize_t out, int len) {
    if (QEMU_SPICE_VMC_WRITE_ENABLED()) {
        QEMU_SPICE_VMC_WRITE(out, len);
    }
}

static inline void trace_spice_vmc_read(int bytes, int len) {
    if (QEMU_SPICE_VMC_READ_ENABLED()) {
        QEMU_SPICE_VMC_READ(bytes, len);
    }
}

static inline void trace_spice_vmc_register_interface(void *scd) {
    if (QEMU_SPICE_VMC_REGISTER_INTERFACE_ENABLED()) {
        QEMU_SPICE_VMC_REGISTER_INTERFACE(scd);
    }
}

static inline void trace_spice_vmc_unregister_interface(void *scd) {
    if (QEMU_SPICE_VMC_UNREGISTER_INTERFACE_ENABLED()) {
        QEMU_SPICE_VMC_UNREGISTER_INTERFACE(scd);
    }
}

static inline void trace_lm32_pic_raise_irq(void) {
    if (QEMU_LM32_PIC_RAISE_IRQ_ENABLED()) {
        QEMU_LM32_PIC_RAISE_IRQ();
    }
}

static inline void trace_lm32_pic_lower_irq(void) {
    if (QEMU_LM32_PIC_LOWER_IRQ_ENABLED()) {
        QEMU_LM32_PIC_LOWER_IRQ();
    }
}

static inline void trace_lm32_pic_interrupt(int irq, int level) {
    if (QEMU_LM32_PIC_INTERRUPT_ENABLED()) {
        QEMU_LM32_PIC_INTERRUPT(irq, level);
    }
}

static inline void trace_lm32_pic_set_im(uint32_t im) {
    if (QEMU_LM32_PIC_SET_IM_ENABLED()) {
        QEMU_LM32_PIC_SET_IM(im);
    }
}

static inline void trace_lm32_pic_set_ip(uint32_t ip) {
    if (QEMU_LM32_PIC_SET_IP_ENABLED()) {
        QEMU_LM32_PIC_SET_IP(ip);
    }
}

static inline void trace_lm32_pic_get_im(uint32_t im) {
    if (QEMU_LM32_PIC_GET_IM_ENABLED()) {
        QEMU_LM32_PIC_GET_IM(im);
    }
}

static inline void trace_lm32_pic_get_ip(uint32_t ip) {
    if (QEMU_LM32_PIC_GET_IP_ENABLED()) {
        QEMU_LM32_PIC_GET_IP(ip);
    }
}

static inline void trace_lm32_juart_get_jtx(uint32_t value) {
    if (QEMU_LM32_JUART_GET_JTX_ENABLED()) {
        QEMU_LM32_JUART_GET_JTX(value);
    }
}

static inline void trace_lm32_juart_set_jtx(uint32_t value) {
    if (QEMU_LM32_JUART_SET_JTX_ENABLED()) {
        QEMU_LM32_JUART_SET_JTX(value);
    }
}

static inline void trace_lm32_juart_get_jrx(uint32_t value) {
    if (QEMU_LM32_JUART_GET_JRX_ENABLED()) {
        QEMU_LM32_JUART_GET_JRX(value);
    }
}

static inline void trace_lm32_juart_set_jrx(uint32_t value) {
    if (QEMU_LM32_JUART_SET_JRX_ENABLED()) {
        QEMU_LM32_JUART_SET_JRX(value);
    }
}

static inline void trace_lm32_timer_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_TIMER_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_TIMER_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_lm32_timer_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_TIMER_MEMORY_READ_ENABLED()) {
        QEMU_LM32_TIMER_MEMORY_READ(addr, value);
    }
}

static inline void trace_lm32_timer_hit(void) {
    if (QEMU_LM32_TIMER_HIT_ENABLED()) {
        QEMU_LM32_TIMER_HIT();
    }
}

static inline void trace_lm32_timer_irq_state(int level) {
    if (QEMU_LM32_TIMER_IRQ_STATE_ENABLED()) {
        QEMU_LM32_TIMER_IRQ_STATE(level);
    }
}

static inline void trace_lm32_uart_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_UART_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_UART_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_lm32_uart_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_UART_MEMORY_READ_ENABLED()) {
        QEMU_LM32_UART_MEMORY_READ(addr, value);
    }
}

static inline void trace_lm32_uart_irq_state(int level) {
    if (QEMU_LM32_UART_IRQ_STATE_ENABLED()) {
        QEMU_LM32_UART_IRQ_STATE(level);
    }
}

static inline void trace_lm32_sys_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_LM32_SYS_MEMORY_WRITE_ENABLED()) {
        QEMU_LM32_SYS_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_ac97_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_AC97_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_AC97_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_ac97_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_AC97_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_AC97_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crrequest(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREQUEST();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_crreply(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREPLY_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_CRREPLY();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmaw(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAW_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAW();
    }
}

static inline void trace_milkymist_ac97_pulse_irq_dmar(void) {
    if (QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAR_ENABLED()) {
        QEMU_MILKYMIST_AC97_PULSE_IRQ_DMAR();
    }
}

static inline void trace_milkymist_ac97_in_cb(int avail, uint32_t remaining) {
    if (QEMU_MILKYMIST_AC97_IN_CB_ENABLED()) {
        QEMU_MILKYMIST_AC97_IN_CB(avail, remaining);
    }
}

static inline void trace_milkymist_ac97_in_cb_transferred(int transferred) {
    if (QEMU_MILKYMIST_AC97_IN_CB_TRANSFERRED_ENABLED()) {
        QEMU_MILKYMIST_AC97_IN_CB_TRANSFERRED(transferred);
    }
}

static inline void trace_milkymist_ac97_out_cb(int free, uint32_t remaining) {
    if (QEMU_MILKYMIST_AC97_OUT_CB_ENABLED()) {
        QEMU_MILKYMIST_AC97_OUT_CB(free, remaining);
    }
}

static inline void trace_milkymist_ac97_out_cb_transferred(int transferred) {
    if (QEMU_MILKYMIST_AC97_OUT_CB_TRANSFERRED_ENABLED()) {
        QEMU_MILKYMIST_AC97_OUT_CB_TRANSFERRED(transferred);
    }
}

static inline void trace_milkymist_hpdmc_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_HPDMC_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_HPDMC_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_hpdmc_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_HPDMC_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_HPDMC_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MEMCARD_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_MEMCARD_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_memcard_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MEMCARD_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MEMCARD_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_minimac2_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_write(uint8_t phy_addr, uint8_t addr, uint16_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MDIO_WRITE_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MDIO_WRITE(phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_mdio_read(uint8_t phy_addr, uint8_t addr, uint16_t value) {
    if (QEMU_MILKYMIST_MINIMAC2_MDIO_READ_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_MDIO_READ(phy_addr, addr, value);
    }
}

static inline void trace_milkymist_minimac2_tx_frame(uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_TX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_TX_FRAME(length);
    }
}

static inline void trace_milkymist_minimac2_rx_frame(const void *buf, uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_RX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RX_FRAME(buf, length);
    }
}

static inline void trace_milkymist_minimac2_drop_rx_frame(const void *buf) {
    if (QEMU_MILKYMIST_MINIMAC2_DROP_RX_FRAME_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_DROP_RX_FRAME(buf);
    }
}

static inline void trace_milkymist_minimac2_rx_transfer(const void *buf, uint32_t length) {
    if (QEMU_MILKYMIST_MINIMAC2_RX_TRANSFER_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RX_TRANSFER(buf, length);
    }
}

static inline void trace_milkymist_minimac2_raise_irq_rx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_RAISE_IRQ_RX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_RAISE_IRQ_RX();
    }
}

static inline void trace_milkymist_minimac2_lower_irq_rx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_LOWER_IRQ_RX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_LOWER_IRQ_RX();
    }
}

static inline void trace_milkymist_minimac2_pulse_irq_tx(void) {
    if (QEMU_MILKYMIST_MINIMAC2_PULSE_IRQ_TX_ENABLED()) {
        QEMU_MILKYMIST_MINIMAC2_PULSE_IRQ_TX();
    }
}

static inline void trace_milkymist_pfpu_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_PFPU_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_PFPU_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_pfpu_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_PFPU_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_PFPU_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_pfpu_vectout(uint32_t a, uint32_t b, uint32_t dma_ptr) {
    if (QEMU_MILKYMIST_PFPU_VECTOUT_ENABLED()) {
        QEMU_MILKYMIST_PFPU_VECTOUT(a, b, dma_ptr);
    }
}

static inline void trace_milkymist_pfpu_pulse_irq(void) {
    if (QEMU_MILKYMIST_PFPU_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_PFPU_PULSE_IRQ();
    }
}

static inline void trace_milkymist_softusb_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SOFTUSB_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_softusb_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SOFTUSB_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_softusb_mevt(uint8_t m) {
    if (QEMU_MILKYMIST_SOFTUSB_MEVT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MEVT(m);
    }
}

static inline void trace_milkymist_softusb_kevt(uint8_t m) {
    if (QEMU_MILKYMIST_SOFTUSB_KEVT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_KEVT(m);
    }
}

static inline void trace_milkymist_softusb_mouse_event(int dx, int dy, int dz, int bs) {
    if (QEMU_MILKYMIST_SOFTUSB_MOUSE_EVENT_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_MOUSE_EVENT(dx, dy, dz, bs);
    }
}

static inline void trace_milkymist_softusb_pulse_irq(void) {
    if (QEMU_MILKYMIST_SOFTUSB_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_SOFTUSB_PULSE_IRQ();
    }
}

static inline void trace_milkymist_sysctl_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_sysctl_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_sysctl_icap_write(uint32_t value) {
    if (QEMU_MILKYMIST_SYSCTL_ICAP_WRITE_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_ICAP_WRITE(value);
    }
}

static inline void trace_milkymist_sysctl_start_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_START_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_START_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_stop_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_STOP_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_STOP_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_start_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_START_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_START_TIMER1();
    }
}

static inline void trace_milkymist_sysctl_stop_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_STOP_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_STOP_TIMER1();
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer0(void) {
    if (QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER0();
    }
}

static inline void trace_milkymist_sysctl_pulse_irq_timer1(void) {
    if (QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1_ENABLED()) {
        QEMU_MILKYMIST_SYSCTL_PULSE_IRQ_TIMER1();
    }
}

static inline void trace_milkymist_tmu2_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_TMU2_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_TMU2_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_tmu2_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_TMU2_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_TMU2_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_tmu2_start(void) {
    if (QEMU_MILKYMIST_TMU2_START_ENABLED()) {
        QEMU_MILKYMIST_TMU2_START();
    }
}

static inline void trace_milkymist_tmu2_pulse_irq(void) {
    if (QEMU_MILKYMIST_TMU2_PULSE_IRQ_ENABLED()) {
        QEMU_MILKYMIST_TMU2_PULSE_IRQ();
    }
}

static inline void trace_milkymist_uart_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_UART_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_UART_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_uart_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_UART_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_UART_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_milkymist_uart_pulse_irq_rx(void) {
    if (QEMU_MILKYMIST_UART_PULSE_IRQ_RX_ENABLED()) {
        QEMU_MILKYMIST_UART_PULSE_IRQ_RX();
    }
}

static inline void trace_milkymist_uart_pulse_irq_tx(void) {
    if (QEMU_MILKYMIST_UART_PULSE_IRQ_TX_ENABLED()) {
        QEMU_MILKYMIST_UART_PULSE_IRQ_TX();
    }
}

static inline void trace_milkymist_vgafb_memory_read(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_VGAFB_MEMORY_READ_ENABLED()) {
        QEMU_MILKYMIST_VGAFB_MEMORY_READ(addr, value);
    }
}

static inline void trace_milkymist_vgafb_memory_write(uint32_t addr, uint32_t value) {
    if (QEMU_MILKYMIST_VGAFB_MEMORY_WRITE_ENABLED()) {
        QEMU_MILKYMIST_VGAFB_MEMORY_WRITE(addr, value);
    }
}

static inline void trace_xen_ram_alloc(unsigned long ram_addr, unsigned long size) {
    if (QEMU_XEN_RAM_ALLOC_ENABLED()) {
        QEMU_XEN_RAM_ALLOC(ram_addr, size);
    }
}

static inline void trace_xen_client_set_memory(uint64_t start_addr, unsigned long size, unsigned long phys_offset, bool log_dirty) {
    if (QEMU_XEN_CLIENT_SET_MEMORY_ENABLED()) {
        QEMU_XEN_CLIENT_SET_MEMORY(start_addr, size, phys_offset, log_dirty);
    }
}

static inline void trace_xen_map_cache(uint64_t phys_addr) {
    if (QEMU_XEN_MAP_CACHE_ENABLED()) {
        QEMU_XEN_MAP_CACHE(phys_addr);
    }
}

static inline void trace_xen_remap_bucket(uint64_t index) {
    if (QEMU_XEN_REMAP_BUCKET_ENABLED()) {
        QEMU_XEN_REMAP_BUCKET(index);
    }
}

static inline void trace_xen_map_cache_return(void* ptr) {
    if (QEMU_XEN_MAP_CACHE_RETURN_ENABLED()) {
        QEMU_XEN_MAP_CACHE_RETURN(ptr);
    }
}

static inline void trace_xen_map_block(uint64_t phys_addr, uint64_t size) {
    if (QEMU_XEN_MAP_BLOCK_ENABLED()) {
        QEMU_XEN_MAP_BLOCK(phys_addr, size);
    }
}

static inline void trace_xen_unmap_block(void* addr, unsigned long size) {
    if (QEMU_XEN_UNMAP_BLOCK_ENABLED()) {
        QEMU_XEN_UNMAP_BLOCK(addr, size);
    }
}

static inline void trace_qemu_put_ram_ptr(void* addr) {
    if (QEMU_QEMU_PUT_RAM_PTR_ENABLED()) {
        QEMU_QEMU_PUT_RAM_PTR(addr);
    }
}

static inline void trace_xen_platform_log(char *s) {
    if (QEMU_XEN_PLATFORM_LOG_ENABLED()) {
        QEMU_XEN_PLATFORM_LOG(s);
    }
}

#endif /* TRACE_H */
